<template>
  <div class="users">
    <div class="wp-title wp-12">Пользователи</div>
    <nav-bar v-model="search" @action="switchInviteUserCard()"
      :isActionActive="showInviteUserCard"/>
    <masonry class="wp-12"
      :columnClass="MasonryColumnClass"
      :cols="MasonryColumns"
      :gutter="MasonryGutter">
      <card title="Приглашение" v-if="showInviteUserCard">
        <card-form :fields="inviteUserCardFields" submitText="Пригласить пользователя"
          :submitFunction="createOrganizationInvite" @submit="switchInviteUserCard()"/>
      </card>
      <card v-for="user in filteredUsers" :key="user.id"
        :title="user.email" :menuItems="cardMenuItems" :data="user"
        @delete="removeMember(user.id)" delete>
        <template #info>
          <div class="wp-field wp-12">
            <div class="wp-field__title">Статус</div>
            <div class="wp-field__content">
              <div class="wp-field__text">
                {{ user.member.is_confirmed ? 'Участник организации' : 'Приглашение отправлено' }}
              </div>
            </div>
          </div>
          <div class="wp-field wp-12">
            <div class="wp-field__title">Логин</div>
            <div class="wp-field__content">
              <div class="wp-field__text">
                {{ user.email }}
              </div>
            </div>
          </div>
        </template>
        <template #roles>
          <card-table :options="cardTableOptions" :index="cardTableIndex"
            @action="(role) => deleteRoleFromUser(user, role)"
            :columnsDefs="cardTableColumnsDefs" :data="user.member.roles.data">
            <template #index="{ row }">
              {{ roleByID[row.id] }}
            </template>
            <template #display="{ row }">
              <boolean-to-circle :val="row.display"/>
            </template>
          </card-table>
        </template>
      </card>
    </masonry>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';

import { MasonryGutter, MasonryColumnClass, MasonryColumns } from '@/shared';

import Card from '@/components/Card.vue';
import CardForm from '@/components/card/CardForm.vue';
import CardTable from '@/components/card/CardTable.vue';
import NavBar from '@/components/NavBar.vue';

import BooleanToCircle from '@/components/utils/BooleanToCircle.vue';

export default {
  name: 'Users',
  components: {
    NavBar,
    Card,
    CardForm,
    CardTable,
    BooleanToCircle,
  },
  data() {
    return {
      MasonryGutter,
      MasonryColumns,
      MasonryColumnClass,
      search: '',
      showInviteUserCard: false,
      inviteUserCardFields: [{
        type: 'text',
        prop: 'email',
        label: 'Логин',
        placeholder: 'Введите логин',
      }],
      bindRoleCardFields: [{
        type: 'autocomplete',
        prop: 'role',
        label: 'Роль',
        placeholder: 'Начните ввод для поиска',
      }],
      cardMenuItems: [
        {
          text: 'Информация',
          prop: 'info',
        },
        {
          text: 'Роли',
          prop: 'roles',
          create: true,
        },
      ],
      cardTableOptions: {
        action: {
          icon: 'trash',
        },
      },
      cardTableIndex: {
        title: 'Название',
        prop: 'name',
      },
      cardTableColumnsDefs: [{
        title: 'D',
        prop: 'display',
      }],
    };
  },
  computed: {
    ...mapState('organization', ['members']),
    ...mapGetters('organization', ['roleByID']),
    title() {
      return this.isInviteModal ? this.titles.invite : this.titles.role;
    },
    filteredUsers() {
      return this.members.filter(user => user.email.toLowerCase().indexOf(
        this.search.toLowerCase(),
      ) !== -1);
    },
  },
  methods: {
    ...mapActions('organization', [
      'getOrganizationMembers',
      'getOrganizationRoles',
      'createOrganizationInvite',
      'deleteOrganizationInvite',
      'unsetRole',
    ]),
    switchInviteUserCard() {
      this.showInviteUserCard = !this.showInviteUserCard;
    },
    async removeMember(userID) {
      try {
        await this.deleteOrganizationInvite(userID);
        this.$toasted.success('Пользователь удален');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
    async deleteRoleFromUser(user, role) {
      try {
        await this.unsetRole({
          id: role.id,
          user_id: user.id,
        });
        this.$toasted.success('Роль откреплена');
        this.$emit('close');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    this.getOrganizationRoles();
    this.getOrganizationMembers();
  },
};
</script>

<style lang="scss" scoped>
</style>
